/* Dock.c generated by valac 0.40.7, the Vala compiler
 * generated from Dock.vala, do not modify */

/*
* Copyright (c) 2016 elementary LLC. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <plank.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <libgnome-desktop/gnome-rr.h>


#define TYPE_DOCK (dock_get_type ())
#define DOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DOCK, Dock))
#define DOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DOCK, DockClass))
#define IS_DOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DOCK))
#define IS_DOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DOCK))
#define DOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DOCK, DockClass))

typedef struct _Dock Dock;
typedef struct _DockClass DockClass;
typedef struct _DockPrivate DockPrivate;
enum  {
	DOCK_0_PROPERTY,
	DOCK_NUM_PROPERTIES
};
static GParamSpec* dock_properties[DOCK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block6Data Block6Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _Dock {
	GtkGrid parent_instance;
	DockPrivate * priv;
};

struct _DockClass {
	GtkGridClass parent_class;
};

struct _DockPrivate {
	GtkLabel* primary_monitor_label;
	GtkSwitch* primary_monitor;
	GtkLabel* monitor_label;
	GtkComboBoxText* monitor;
	PlankDockPreferences* dock_preferences;
};

struct _Block6Data {
	int _ref_count_;
	Dock* self;
	GraniteWidgetsModeButton* icon_size;
	gint current;
	GtkComboBoxText* hide_mode;
	PlankHideType* hide_mode_ids;
	gint hide_mode_ids_length1;
	gint _hide_mode_ids_size_;
	GtkSwitch* hide_switch;
};


static gpointer dock_parent_class = NULL;

GType dock_get_type (void) G_GNUC_CONST;
#define DOCK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DOCK, DockPrivate))
Dock* dock_new (void);
Dock* dock_construct (GType object_type);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
#define CONSTANTS_PLANKDATADIR "/usr/share/plank"
static void __lambda17_ (Block6Data* _data6_);
static void ___lambda17__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                            GtkWidget* widget,
                                                            gpointer self);
static void __lambda18_ (Block6Data* _data6_);
static void ___lambda18__gtk_combo_box_changed (GtkComboBox* _sender,
                                         gpointer self);
static void __lambda19_ (Block6Data* _data6_);
static void ___lambda19__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda20_ (Dock* self);
static gchar** dock_get_monitor_plug_names (GdkScreen* screen,
                                     int* result_length1);
static void ___lambda20__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda21_ (Dock* self);
static void ___lambda21__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda22_ (Dock* self);
static void dock_check_for_screens (Dock* self);
static void ___lambda22__gdk_screen_monitors_changed (GdkScreen* _sender,
                                               gpointer self);
static gint dock_find_monitor_number (GdkScreen* screen,
                               const gchar* plug_name);
static void dock_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}


static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		Dock* self;
		self = _data6_->self;
		_g_object_unref0 (_data6_->hide_switch);
		_data6_->hide_mode_ids = (g_free (_data6_->hide_mode_ids), NULL);
		_g_object_unref0 (_data6_->hide_mode);
		_g_object_unref0 (_data6_->icon_size);
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}


static void
__lambda17_ (Block6Data* _data6_)
{
	Dock* self;
	GraniteWidgetsModeButton* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	self = _data6_->self;
	_tmp0_ = _data6_->icon_size;
	_tmp1_ = granite_widgets_mode_button_get_selected (_tmp0_);
	_tmp2_ = _tmp1_;
	switch (_tmp2_) {
		case 0:
		{
			PlankDockPreferences* _tmp3_;
			_tmp3_ = self->priv->dock_preferences;
			plank_dock_preferences_set_IconSize (_tmp3_, 32);
			break;
		}
		case 1:
		{
			PlankDockPreferences* _tmp4_;
			_tmp4_ = self->priv->dock_preferences;
			plank_dock_preferences_set_IconSize (_tmp4_, 48);
			break;
		}
		case 2:
		{
			PlankDockPreferences* _tmp5_;
			_tmp5_ = self->priv->dock_preferences;
			plank_dock_preferences_set_IconSize (_tmp5_, 64);
			break;
		}
		case 3:
		{
			PlankDockPreferences* _tmp6_;
			gint _tmp7_;
			_tmp6_ = self->priv->dock_preferences;
			_tmp7_ = _data6_->current;
			plank_dock_preferences_set_IconSize (_tmp6_, _tmp7_);
			break;
		}
		default:
		break;
	}
}


static void
___lambda17__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                       GtkWidget* widget,
                                                       gpointer self)
{
	__lambda17_ (self);
}


static void
__lambda18_ (Block6Data* _data6_)
{
	Dock* self;
	PlankDockPreferences* _tmp0_;
	PlankHideType* _tmp1_;
	gint _tmp1__length1;
	GtkComboBoxText* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	PlankHideType _tmp5_;
	self = _data6_->self;
	_tmp0_ = self->priv->dock_preferences;
	_tmp1_ = _data6_->hide_mode_ids;
	_tmp1__length1 = _data6_->hide_mode_ids_length1;
	_tmp2_ = _data6_->hide_mode;
	_tmp3_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp1_[_tmp4_];
	plank_dock_preferences_set_HideMode (_tmp0_, _tmp5_);
}


static void
___lambda18__gtk_combo_box_changed (GtkComboBox* _sender,
                                    gpointer self)
{
	__lambda18_ (self);
}


static void
__lambda19_ (Block6Data* _data6_)
{
	Dock* self;
	GtkSwitch* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = _data6_->self;
	_tmp0_ = _data6_->hide_switch;
	_tmp1_ = gtk_switch_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		PlankDockPreferences* _tmp3_;
		PlankHideType* _tmp4_;
		gint _tmp4__length1;
		GtkComboBoxText* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		PlankHideType _tmp8_;
		_tmp3_ = self->priv->dock_preferences;
		_tmp4_ = _data6_->hide_mode_ids;
		_tmp4__length1 = _data6_->hide_mode_ids_length1;
		_tmp5_ = _data6_->hide_mode;
		_tmp6_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = _tmp4_[_tmp7_];
		plank_dock_preferences_set_HideMode (_tmp3_, _tmp8_);
	} else {
		PlankDockPreferences* _tmp9_;
		_tmp9_ = self->priv->dock_preferences;
		plank_dock_preferences_set_HideMode (_tmp9_, PLANK_HIDE_TYPE_NONE);
	}
}


static void
___lambda19__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda19_ (self);
}


static void
__lambda20_ (Dock* self)
{
	GtkSwitch* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = self->priv->primary_monitor;
	_tmp1_ = gtk_switch_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == TRUE) {
		PlankDockPreferences* _tmp3_;
		GtkLabel* _tmp4_;
		GtkComboBoxText* _tmp5_;
		_tmp3_ = self->priv->dock_preferences;
		plank_dock_preferences_set_Monitor (_tmp3_, "");
		_tmp4_ = self->priv->monitor_label;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, FALSE);
		_tmp5_ = self->priv->monitor;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, FALSE);
	} else {
		gchar** plug_names = NULL;
		GdkScreen* _tmp6_;
		gint _tmp7_;
		gchar** _tmp8_;
		gint plug_names_length1;
		gint _plug_names_size_;
		gchar** _tmp9_;
		gint _tmp9__length1;
		GtkComboBoxText* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		GtkLabel* _tmp19_;
		GtkComboBoxText* _tmp20_;
		_tmp6_ = gtk_widget_get_screen ((GtkWidget*) self);
		_tmp8_ = dock_get_monitor_plug_names (_tmp6_, &_tmp7_);
		plug_names = _tmp8_;
		plug_names_length1 = _tmp7_;
		_plug_names_size_ = plug_names_length1;
		_tmp9_ = plug_names;
		_tmp9__length1 = plug_names_length1;
		_tmp10_ = self->priv->monitor;
		_tmp11_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp10_);
		_tmp12_ = _tmp11_;
		if (_tmp9__length1 > _tmp12_) {
			PlankDockPreferences* _tmp13_;
			gchar** _tmp14_;
			gint _tmp14__length1;
			GtkComboBoxText* _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
			const gchar* _tmp18_;
			_tmp13_ = self->priv->dock_preferences;
			_tmp14_ = plug_names;
			_tmp14__length1 = plug_names_length1;
			_tmp15_ = self->priv->monitor;
			_tmp16_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp15_);
			_tmp17_ = _tmp16_;
			_tmp18_ = _tmp14_[_tmp17_];
			plank_dock_preferences_set_Monitor (_tmp13_, _tmp18_);
		}
		_tmp19_ = self->priv->monitor_label;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, TRUE);
		_tmp20_ = self->priv->monitor;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp20_, TRUE);
		plug_names = (_vala_array_free (plug_names, plug_names_length1, (GDestroyNotify) g_free), NULL);
	}
}


static void
___lambda20__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda20_ ((Dock*) self);
}


static void
__lambda21_ (Dock* self)
{
	gboolean _tmp0_ = FALSE;
	GtkComboBoxText* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	_tmp1_ = self->priv->monitor;
	_tmp2_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ >= 0) {
		GtkSwitch* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		_tmp4_ = self->priv->primary_monitor;
		_tmp5_ = gtk_switch_get_active (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = _tmp6_ == FALSE;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar** plug_names = NULL;
		GdkScreen* _tmp7_;
		gint _tmp8_;
		gchar** _tmp9_;
		gint plug_names_length1;
		gint _plug_names_size_;
		gchar** _tmp10_;
		gint _tmp10__length1;
		GtkComboBoxText* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		_tmp7_ = gtk_widget_get_screen ((GtkWidget*) self);
		_tmp9_ = dock_get_monitor_plug_names (_tmp7_, &_tmp8_);
		plug_names = _tmp9_;
		plug_names_length1 = _tmp8_;
		_plug_names_size_ = plug_names_length1;
		_tmp10_ = plug_names;
		_tmp10__length1 = plug_names_length1;
		_tmp11_ = self->priv->monitor;
		_tmp12_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp11_);
		_tmp13_ = _tmp12_;
		if (_tmp10__length1 > _tmp13_) {
			PlankDockPreferences* _tmp14_;
			gchar** _tmp15_;
			gint _tmp15__length1;
			GtkComboBoxText* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			const gchar* _tmp19_;
			_tmp14_ = self->priv->dock_preferences;
			_tmp15_ = plug_names;
			_tmp15__length1 = plug_names_length1;
			_tmp16_ = self->priv->monitor;
			_tmp17_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp16_);
			_tmp18_ = _tmp17_;
			_tmp19_ = _tmp15_[_tmp18_];
			plank_dock_preferences_set_Monitor (_tmp14_, _tmp19_);
		}
		plug_names = (_vala_array_free (plug_names, plug_names_length1, (GDestroyNotify) g_free), NULL);
	}
}


static void
___lambda21__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda21_ ((Dock*) self);
}


static void
__lambda22_ (Dock* self)
{
	dock_check_for_screens (self);
}


static void
___lambda22__gdk_screen_monitors_changed (GdkScreen* _sender,
                                          gpointer self)
{
	__lambda22_ ((Dock*) self);
}


Dock*
dock_construct (GType object_type)
{
	Dock * self = NULL;
	Block6Data* _data6_;
	GraniteWidgetsModeButton* _tmp0_;
	GraniteWidgetsModeButton* _tmp1_;
	GraniteWidgetsModeButton* _tmp2_;
	GraniteWidgetsModeButton* _tmp3_;
	PlankDockPreferences* _tmp4_;
	PlankDockPreferences* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GraniteWidgetsModeButton* _tmp17_;
	GtkSwitch* pressure_switch = NULL;
	GtkSwitch* _tmp18_;
	GtkSwitch* _tmp19_;
	GtkSwitch* _tmp20_;
	PlankDockPreferences* _tmp21_;
	GtkSwitch* _tmp22_;
	GtkComboBoxText* _tmp23_;
	GtkComboBoxText* _tmp24_;
	GtkComboBoxText* _tmp25_;
	GtkComboBoxText* _tmp26_;
	GtkComboBoxText* _tmp27_;
	PlankHideType* _tmp28_;
	GtkSwitch* _tmp29_;
	GtkSwitch* _tmp30_;
	GtkSwitch* _tmp31_;
	gboolean hide_none = FALSE;
	PlankDockPreferences* _tmp32_;
	PlankHideType _tmp33_;
	PlankHideType _tmp34_;
	GtkSwitch* _tmp35_;
	gboolean _tmp36_;
	gboolean _tmp37_;
	GtkComboBoxText* _tmp51_;
	GtkSwitch* _tmp52_;
	GtkSwitch* _tmp53_;
	GtkSwitch* _tmp54_;
	GtkComboBoxText* _tmp55_;
	GtkSwitch* _tmp56_;
	GtkComboBoxText* _tmp57_;
	GtkLabel* _tmp58_;
	GtkLabel* _tmp59_;
	GtkLabel* _tmp60_;
	GtkLabel* _tmp61_;
	GtkLabel* _tmp62_;
	GtkLabel* _tmp63_;
	GtkSwitch* _tmp64_;
	GtkSwitch* _tmp65_;
	GtkSwitch* _tmp66_;
	GtkSwitch* _tmp67_;
	PlankDockPreferences* _tmp68_;
	const gchar* _tmp69_;
	const gchar* _tmp70_;
	GtkComboBoxText* _tmp71_;
	GdkScreen* _tmp72_;
	GtkLabel* icon_label = NULL;
	GtkLabel* _tmp73_;
	GtkLabel* hide_label = NULL;
	GtkLabel* _tmp74_;
	GtkGrid* primary_monitor_grid = NULL;
	GtkGrid* _tmp75_;
	GtkSwitch* _tmp76_;
	GtkLabel* pressure_label = NULL;
	GtkLabel* _tmp77_;
	GraniteWidgetsModeButton* _tmp78_;
	GtkComboBoxText* _tmp79_;
	GtkSwitch* _tmp80_;
	GtkLabel* _tmp81_;
	GtkLabel* _tmp82_;
	GtkComboBoxText* _tmp83_;
	GtkSwitch* _tmp84_;
	_data6_ = g_slice_new0 (Block6Data);
	_data6_->_ref_count_ = 1;
	self = (Dock*) g_object_new (object_type, NULL);
	_data6_->self = g_object_ref (self);
	gtk_grid_set_column_spacing ((GtkGrid*) self, 12);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	gtk_grid_set_row_spacing ((GtkGrid*) self, 6);
	gtk_widget_set_margin_end ((GtkWidget*) self, 6);
	gtk_widget_set_margin_start ((GtkWidget*) self, 6);
	_tmp0_ = granite_widgets_mode_button_new ();
	g_object_ref_sink (_tmp0_);
	_data6_->icon_size = _tmp0_;
	_tmp1_ = _data6_->icon_size;
	granite_widgets_mode_button_append_text (_tmp1_, _ ("Small"));
	_tmp2_ = _data6_->icon_size;
	granite_widgets_mode_button_append_text (_tmp2_, _ ("Normal"));
	_tmp3_ = _data6_->icon_size;
	granite_widgets_mode_button_append_text (_tmp3_, _ ("Large"));
	plank_paths_initialize ("plank", CONSTANTS_PLANKDATADIR);
	_tmp4_ = plank_dock_preferences_new ("dock1");
	_g_object_unref0 (self->priv->dock_preferences);
	self->priv->dock_preferences = _tmp4_;
	_tmp5_ = self->priv->dock_preferences;
	_tmp6_ = plank_dock_preferences_get_IconSize (_tmp5_);
	_tmp7_ = _tmp6_;
	_data6_->current = _tmp7_;
	_tmp8_ = _data6_->current;
	switch (_tmp8_) {
		case 32:
		{
			GraniteWidgetsModeButton* _tmp9_;
			_tmp9_ = _data6_->icon_size;
			granite_widgets_mode_button_set_selected (_tmp9_, 0);
			break;
		}
		case 48:
		{
			GraniteWidgetsModeButton* _tmp10_;
			_tmp10_ = _data6_->icon_size;
			granite_widgets_mode_button_set_selected (_tmp10_, 1);
			break;
		}
		case 64:
		{
			GraniteWidgetsModeButton* _tmp11_;
			_tmp11_ = _data6_->icon_size;
			granite_widgets_mode_button_set_selected (_tmp11_, 2);
			break;
		}
		default:
		{
			GraniteWidgetsModeButton* _tmp12_;
			gint _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			GraniteWidgetsModeButton* _tmp16_;
			_tmp12_ = _data6_->icon_size;
			_tmp13_ = _data6_->current;
			_tmp14_ = g_strdup_printf (_ ("Custom (%dpx)"), _tmp13_);
			_tmp15_ = _tmp14_;
			granite_widgets_mode_button_append_text (_tmp12_, _tmp15_);
			_g_free0 (_tmp15_);
			_tmp16_ = _data6_->icon_size;
			granite_widgets_mode_button_set_selected (_tmp16_, 3);
			break;
		}
	}
	_tmp17_ = _data6_->icon_size;
	g_signal_connect_data (_tmp17_, "mode-changed", (GCallback) ___lambda17__granite_widgets_mode_button_mode_changed, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
	_tmp18_ = (GtkSwitch*) gtk_switch_new ();
	g_object_ref_sink (_tmp18_);
	pressure_switch = _tmp18_;
	_tmp19_ = pressure_switch;
	gtk_widget_set_halign ((GtkWidget*) _tmp19_, GTK_ALIGN_START);
	_tmp20_ = pressure_switch;
	gtk_widget_set_valign ((GtkWidget*) _tmp20_, GTK_ALIGN_CENTER);
	_tmp21_ = self->priv->dock_preferences;
	_tmp22_ = pressure_switch;
	g_object_bind_property_with_closures ((GObject*) _tmp21_, "PressureReveal", (GObject*) _tmp22_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp23_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp23_);
	_data6_->hide_mode = _tmp23_;
	_tmp24_ = _data6_->hide_mode;
	gtk_combo_box_text_append_text (_tmp24_, _ ("Focused window is maximized"));
	_tmp25_ = _data6_->hide_mode;
	gtk_combo_box_text_append_text (_tmp25_, _ ("Focused window overlaps the dock"));
	_tmp26_ = _data6_->hide_mode;
	gtk_combo_box_text_append_text (_tmp26_, _ ("Any window overlaps the dock"));
	_tmp27_ = _data6_->hide_mode;
	gtk_combo_box_text_append_text (_tmp27_, _ ("Not being used"));
	_tmp28_ = g_new0 (PlankHideType, 4);
	_tmp28_[0] = PLANK_HIDE_TYPE_DODGE_MAXIMIZED;
	_tmp28_[1] = PLANK_HIDE_TYPE_INTELLIGENT;
	_tmp28_[2] = PLANK_HIDE_TYPE_WINDOW_DODGE;
	_tmp28_[3] = PLANK_HIDE_TYPE_AUTO;
	_data6_->hide_mode_ids = _tmp28_;
	_data6_->hide_mode_ids_length1 = 4;
	_data6_->_hide_mode_ids_size_ = _data6_->hide_mode_ids_length1;
	_tmp29_ = (GtkSwitch*) gtk_switch_new ();
	g_object_ref_sink (_tmp29_);
	_data6_->hide_switch = _tmp29_;
	_tmp30_ = _data6_->hide_switch;
	gtk_widget_set_halign ((GtkWidget*) _tmp30_, GTK_ALIGN_START);
	_tmp31_ = _data6_->hide_switch;
	gtk_widget_set_valign ((GtkWidget*) _tmp31_, GTK_ALIGN_CENTER);
	_tmp32_ = self->priv->dock_preferences;
	_tmp33_ = plank_dock_preferences_get_HideMode (_tmp32_);
	_tmp34_ = _tmp33_;
	hide_none = _tmp34_ != PLANK_HIDE_TYPE_NONE;
	_tmp35_ = _data6_->hide_switch;
	_tmp36_ = hide_none;
	gtk_switch_set_active (_tmp35_, _tmp36_);
	_tmp37_ = hide_none;
	if (_tmp37_) {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp38_ = FALSE;
				_tmp38_ = TRUE;
				while (TRUE) {
					gint _tmp40_;
					PlankHideType* _tmp41_;
					gint _tmp41__length1;
					PlankHideType* _tmp42_;
					gint _tmp42__length1;
					gint _tmp43_;
					PlankHideType _tmp44_;
					PlankDockPreferences* _tmp45_;
					PlankHideType _tmp46_;
					PlankHideType _tmp47_;
					if (!_tmp38_) {
						gint _tmp39_;
						_tmp39_ = i;
						i = _tmp39_ + 1;
					}
					_tmp38_ = FALSE;
					_tmp40_ = i;
					_tmp41_ = _data6_->hide_mode_ids;
					_tmp41__length1 = _data6_->hide_mode_ids_length1;
					if (!(_tmp40_ < _tmp41__length1)) {
						break;
					}
					_tmp42_ = _data6_->hide_mode_ids;
					_tmp42__length1 = _data6_->hide_mode_ids_length1;
					_tmp43_ = i;
					_tmp44_ = _tmp42_[_tmp43_];
					_tmp45_ = self->priv->dock_preferences;
					_tmp46_ = plank_dock_preferences_get_HideMode (_tmp45_);
					_tmp47_ = _tmp46_;
					if (_tmp44_ == _tmp47_) {
						GtkComboBoxText* _tmp48_;
						gint _tmp49_;
						_tmp48_ = _data6_->hide_mode;
						_tmp49_ = i;
						gtk_combo_box_set_active ((GtkComboBox*) _tmp48_, _tmp49_);
					}
				}
			}
		}
	} else {
		GtkComboBoxText* _tmp50_;
		_tmp50_ = _data6_->hide_mode;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp50_, FALSE);
	}
	_tmp51_ = _data6_->hide_mode;
	g_signal_connect_data ((GtkComboBox*) _tmp51_, "changed", (GCallback) ___lambda18__gtk_combo_box_changed, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
	_tmp52_ = _data6_->hide_switch;
	_tmp53_ = pressure_switch;
	g_object_bind_property_with_closures ((GObject*) _tmp52_, "active", (GObject*) _tmp53_, "sensitive", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp54_ = _data6_->hide_switch;
	_tmp55_ = _data6_->hide_mode;
	g_object_bind_property_with_closures ((GObject*) _tmp54_, "active", (GObject*) _tmp55_, "sensitive", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp56_ = _data6_->hide_switch;
	g_signal_connect_data ((GObject*) _tmp56_, "notify::active", (GCallback) ___lambda19__g_object_notify, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
	_tmp57_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp57_);
	_g_object_unref0 (self->priv->monitor);
	self->priv->monitor = _tmp57_;
	_tmp58_ = (GtkLabel*) gtk_label_new (_ ("Primary display:"));
	g_object_ref_sink (_tmp58_);
	_g_object_unref0 (self->priv->primary_monitor_label);
	self->priv->primary_monitor_label = _tmp58_;
	_tmp59_ = self->priv->primary_monitor_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp59_, GTK_ALIGN_END);
	_tmp60_ = self->priv->primary_monitor_label;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp60_, TRUE);
	_tmp61_ = (GtkLabel*) gtk_label_new (_ ("Display:"));
	g_object_ref_sink (_tmp61_);
	_g_object_unref0 (self->priv->monitor_label);
	self->priv->monitor_label = _tmp61_;
	_tmp62_ = self->priv->monitor_label;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp62_, TRUE);
	_tmp63_ = self->priv->monitor_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp63_, GTK_ALIGN_END);
	_tmp64_ = (GtkSwitch*) gtk_switch_new ();
	g_object_ref_sink (_tmp64_);
	_g_object_unref0 (self->priv->primary_monitor);
	self->priv->primary_monitor = _tmp64_;
	_tmp65_ = self->priv->primary_monitor;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp65_, TRUE);
	_tmp66_ = self->priv->primary_monitor;
	g_signal_connect_object ((GObject*) _tmp66_, "notify::active", (GCallback) ___lambda20__g_object_notify, self, 0);
	_tmp67_ = self->priv->primary_monitor;
	_tmp68_ = self->priv->dock_preferences;
	_tmp69_ = plank_dock_preferences_get_Monitor (_tmp68_);
	_tmp70_ = _tmp69_;
	gtk_switch_set_active (_tmp67_, g_strcmp0 (_tmp70_, "") == 0);
	_tmp71_ = self->priv->monitor;
	g_signal_connect_object ((GObject*) _tmp71_, "notify::active", (GCallback) ___lambda21__g_object_notify, self, 0);
	_tmp72_ = gtk_widget_get_screen ((GtkWidget*) self);
	g_signal_connect_object (_tmp72_, "monitors-changed", (GCallback) ___lambda22__gdk_screen_monitors_changed, self, 0);
	_tmp73_ = (GtkLabel*) gtk_label_new (_ ("Icon size:"));
	g_object_ref_sink (_tmp73_);
	icon_label = _tmp73_;
	gtk_widget_set_halign ((GtkWidget*) icon_label, GTK_ALIGN_END);
	_tmp74_ = (GtkLabel*) gtk_label_new (_ ("Hide when:"));
	g_object_ref_sink (_tmp74_);
	hide_label = _tmp74_;
	gtk_widget_set_halign ((GtkWidget*) hide_label, GTK_ALIGN_END);
	_tmp75_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp75_);
	primary_monitor_grid = _tmp75_;
	_tmp76_ = self->priv->primary_monitor;
	gtk_container_add ((GtkContainer*) primary_monitor_grid, (GtkWidget*) _tmp76_);
	_tmp77_ = (GtkLabel*) gtk_label_new (_ ("Pressure reveal:"));
	g_object_ref_sink (_tmp77_);
	pressure_label = _tmp77_;
	gtk_widget_set_halign ((GtkWidget*) pressure_label, GTK_ALIGN_END);
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) icon_label, 1, 0, 1, 1);
	_tmp78_ = _data6_->icon_size;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp78_, 2, 0, 1, 1);
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) hide_label, 1, 1, 1, 1);
	_tmp79_ = _data6_->hide_mode;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp79_, 2, 1, 1, 1);
	_tmp80_ = _data6_->hide_switch;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp80_, 3, 1, 1, 1);
	_tmp81_ = self->priv->primary_monitor_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp81_, 1, 3, 1, 1);
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) primary_monitor_grid, 2, 3, 1, 1);
	_tmp82_ = self->priv->monitor_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp82_, 1, 4, 1, 1);
	_tmp83_ = self->priv->monitor;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp83_, 2, 4, 1, 1);
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) pressure_label, 1, 5, 1, 1);
	_tmp84_ = pressure_switch;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp84_, 2, 5, 1, 1);
	dock_check_for_screens (self);
	_g_object_unref0 (pressure_label);
	_g_object_unref0 (primary_monitor_grid);
	_g_object_unref0 (hide_label);
	_g_object_unref0 (icon_label);
	_g_object_unref0 (pressure_switch);
	block6_data_unref (_data6_);
	_data6_ = NULL;
	return self;
}


Dock*
dock_new (void)
{
	return dock_construct (TYPE_DOCK);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
dock_check_for_screens (Dock* self)
{
	gint i = 0;
	gint primary_screen = 0;
	GdkScreen* default_screen = NULL;
	GdkScreen* _tmp0_;
	GdkScreen* _tmp1_;
	GtkComboBoxText* _tmp2_;
	gint _tmp42_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	i = 0;
	primary_screen = 0;
	_tmp0_ = gtk_widget_get_screen ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	default_screen = _tmp1_;
	_tmp2_ = self->priv->monitor;
	gtk_combo_box_text_remove_all (_tmp2_);
	{
		GnomeRRScreen* screen = NULL;
		GdkScreen* _tmp3_;
		GnomeRRScreen* _tmp4_;
		_tmp3_ = default_screen;
		_tmp4_ = gnome_rr_screen_new (_tmp3_, &_inner_error_);
		screen = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch17_g_error;
		}
		{
			gboolean _tmp5_ = FALSE;
			i = 0;
			_tmp5_ = TRUE;
			while (TRUE) {
				gint _tmp7_;
				GdkScreen* _tmp8_;
				gchar* monitor_plug_name = NULL;
				GdkScreen* _tmp9_;
				gint _tmp10_;
				gchar* _tmp11_;
				const gchar* _tmp12_;
				GtkComboBoxText* _tmp28_;
				gint _tmp29_;
				gchar* _tmp30_;
				gchar* _tmp31_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = i;
					i = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp7_ = i;
				_tmp8_ = default_screen;
				if (!(_tmp7_ < gdk_screen_get_n_monitors (_tmp8_))) {
					break;
				}
				_tmp9_ = default_screen;
				_tmp10_ = i;
				_tmp11_ = gdk_screen_get_monitor_plug_name (_tmp9_, _tmp10_);
				monitor_plug_name = _tmp11_;
				_tmp12_ = monitor_plug_name;
				if (_tmp12_ != NULL) {
					GnomeRROutput* output = NULL;
					GnomeRRScreen* _tmp13_;
					const gchar* _tmp14_;
					GnomeRROutput* _tmp15_;
					gboolean _tmp16_ = FALSE;
					gboolean _tmp17_ = FALSE;
					GnomeRROutput* _tmp18_;
					_tmp13_ = screen;
					_tmp14_ = monitor_plug_name;
					_tmp15_ = gnome_rr_screen_get_output_by_name (_tmp13_, _tmp14_);
					output = _tmp15_;
					_tmp18_ = output;
					if (_tmp18_ != NULL) {
						GnomeRROutput* _tmp19_;
						const gchar* _tmp20_;
						_tmp19_ = output;
						_tmp20_ = gnome_rr_output_get_display_name (_tmp19_);
						_tmp17_ = _tmp20_ != NULL;
					} else {
						_tmp17_ = FALSE;
					}
					if (_tmp17_) {
						GnomeRROutput* _tmp21_;
						const gchar* _tmp22_;
						_tmp21_ = output;
						_tmp22_ = gnome_rr_output_get_display_name (_tmp21_);
						_tmp16_ = g_strcmp0 (_tmp22_, "") != 0;
					} else {
						_tmp16_ = FALSE;
					}
					if (_tmp16_) {
						GtkComboBoxText* _tmp23_;
						GnomeRROutput* _tmp24_;
						const gchar* _tmp25_;
						GnomeRROutput* _tmp26_;
						_tmp23_ = self->priv->monitor;
						_tmp24_ = output;
						_tmp25_ = gnome_rr_output_get_display_name (_tmp24_);
						gtk_combo_box_text_append_text (_tmp23_, _tmp25_);
						_tmp26_ = output;
						if (gnome_rr_output_get_is_primary (_tmp26_) == TRUE) {
							gint _tmp27_;
							_tmp27_ = i;
							primary_screen = _tmp27_;
						}
						_g_free0 (monitor_plug_name);
						continue;
					}
				}
				_tmp28_ = self->priv->monitor;
				_tmp29_ = i;
				_tmp30_ = g_strdup_printf (_ ("Monitor %d"), _tmp29_ + 1);
				_tmp31_ = _tmp30_;
				gtk_combo_box_text_append_text (_tmp28_, _tmp31_);
				_g_free0 (_tmp31_);
				_g_free0 (monitor_plug_name);
			}
		}
		_g_object_unref0 (screen);
	}
	goto __finally17;
	__catch17_g_error:
	{
		GError* e = NULL;
		GError* _tmp32_;
		const gchar* _tmp33_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp32_ = e;
		_tmp33_ = _tmp32_->message;
		g_critical ("Dock.vala:205: %s", _tmp33_);
		{
			gboolean _tmp34_ = FALSE;
			i = 0;
			_tmp34_ = TRUE;
			while (TRUE) {
				gint _tmp36_;
				GdkScreen* _tmp37_;
				GtkComboBoxText* _tmp38_;
				gint _tmp39_;
				gchar* _tmp40_;
				gchar* _tmp41_;
				if (!_tmp34_) {
					gint _tmp35_;
					_tmp35_ = i;
					i = _tmp35_ + 1;
				}
				_tmp34_ = FALSE;
				_tmp36_ = i;
				_tmp37_ = default_screen;
				if (!(_tmp36_ < gdk_screen_get_n_monitors (_tmp37_))) {
					break;
				}
				_tmp38_ = self->priv->monitor;
				_tmp39_ = i;
				_tmp40_ = g_strdup_printf (_ ("Display %d"), _tmp39_ + 1);
				_tmp41_ = _tmp40_;
				gtk_combo_box_text_append_text (_tmp38_, _tmp41_);
				_g_free0 (_tmp41_);
			}
		}
		_g_error_free0 (e);
	}
	__finally17:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (default_screen);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp42_ = i;
	if (_tmp42_ <= 1) {
		GtkLabel* _tmp43_;
		GtkSwitch* _tmp44_;
		GtkLabel* _tmp45_;
		GtkComboBoxText* _tmp46_;
		GtkComboBoxText* _tmp47_;
		_tmp43_ = self->priv->primary_monitor_label;
		gtk_widget_hide ((GtkWidget*) _tmp43_);
		_tmp44_ = self->priv->primary_monitor;
		gtk_widget_hide ((GtkWidget*) _tmp44_);
		_tmp45_ = self->priv->monitor_label;
		gtk_widget_hide ((GtkWidget*) _tmp45_);
		_tmp46_ = self->priv->monitor;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp46_, TRUE);
		_tmp47_ = self->priv->monitor;
		gtk_widget_hide ((GtkWidget*) _tmp47_);
	} else {
		PlankDockPreferences* _tmp48_;
		const gchar* _tmp49_;
		const gchar* _tmp50_;
		GtkLabel* _tmp58_;
		GtkSwitch* _tmp59_;
		GtkLabel* _tmp60_;
		GtkComboBoxText* _tmp61_;
		_tmp48_ = self->priv->dock_preferences;
		_tmp49_ = plank_dock_preferences_get_Monitor (_tmp48_);
		_tmp50_ = _tmp49_;
		if (g_strcmp0 (_tmp50_, "") != 0) {
			GtkComboBoxText* _tmp51_;
			GdkScreen* _tmp52_;
			PlankDockPreferences* _tmp53_;
			const gchar* _tmp54_;
			const gchar* _tmp55_;
			_tmp51_ = self->priv->monitor;
			_tmp52_ = gtk_widget_get_screen ((GtkWidget*) self);
			_tmp53_ = self->priv->dock_preferences;
			_tmp54_ = plank_dock_preferences_get_Monitor (_tmp53_);
			_tmp55_ = _tmp54_;
			gtk_combo_box_set_active ((GtkComboBox*) _tmp51_, dock_find_monitor_number (_tmp52_, _tmp55_));
		} else {
			GtkComboBoxText* _tmp56_;
			gint _tmp57_;
			_tmp56_ = self->priv->monitor;
			_tmp57_ = primary_screen;
			gtk_combo_box_set_active ((GtkComboBox*) _tmp56_, _tmp57_);
		}
		_tmp58_ = self->priv->primary_monitor_label;
		gtk_widget_show ((GtkWidget*) _tmp58_);
		_tmp59_ = self->priv->primary_monitor;
		gtk_widget_show ((GtkWidget*) _tmp59_);
		_tmp60_ = self->priv->monitor_label;
		gtk_widget_show ((GtkWidget*) _tmp60_);
		_tmp61_ = self->priv->monitor;
		gtk_widget_show ((GtkWidget*) _tmp61_);
	}
	_g_object_unref0 (default_screen);
}


static gchar**
dock_get_monitor_plug_names (GdkScreen* screen,
                             int* result_length1)
{
	gchar** result = NULL;
	gint n_monitors = 0;
	gchar** _result_ = NULL;
	gint _tmp0_;
	gchar** _tmp1_;
	gint _result__length1;
	gint __result__size_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	g_return_val_if_fail (screen != NULL, NULL);
	n_monitors = gdk_screen_get_n_monitors (screen);
	_tmp0_ = n_monitors;
	_tmp1_ = g_new0 (gchar*, _tmp0_ + 1);
	_result_ = _tmp1_;
	_result__length1 = _tmp0_;
	__result__size_ = _result__length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gint _tmp4_;
				gint _tmp5_;
				gchar** _tmp6_;
				gint _tmp6__length1;
				gint _tmp7_;
				gint _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = i;
				_tmp5_ = n_monitors;
				if (!(_tmp4_ < _tmp5_)) {
					break;
				}
				_tmp6_ = _result_;
				_tmp6__length1 = _result__length1;
				_tmp7_ = i;
				_tmp8_ = i;
				_tmp9_ = gdk_screen_get_monitor_plug_name (screen, _tmp8_);
				_g_free0 (_tmp6_[_tmp7_]);
				_tmp6_[_tmp7_] = _tmp9_;
				_tmp10_ = _tmp6_[_tmp7_];
			}
		}
	}
	_tmp11_ = _result_;
	_tmp11__length1 = _result__length1;
	if (result_length1) {
		*result_length1 = _tmp11__length1;
	}
	result = _tmp11_;
	return result;
}


static gint
dock_find_monitor_number (GdkScreen* screen,
                          const gchar* plug_name)
{
	gint result = 0;
	gint n_monitors = 0;
	g_return_val_if_fail (screen != NULL, 0);
	g_return_val_if_fail (plug_name != NULL, 0);
	n_monitors = gdk_screen_get_n_monitors (screen);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				gint _tmp3_;
				gchar* name = NULL;
				gint _tmp4_;
				gchar* _tmp5_;
				const gchar* _tmp6_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp3_ = n_monitors;
				if (!(_tmp2_ < _tmp3_)) {
					break;
				}
				_tmp4_ = i;
				_tmp5_ = gdk_screen_get_monitor_plug_name (screen, _tmp4_);
				name = _tmp5_;
				_tmp6_ = name;
				if (g_strcmp0 (plug_name, _tmp6_) == 0) {
					result = i;
					_g_free0 (name);
					return result;
				}
				_g_free0 (name);
			}
		}
	}
	result = gdk_screen_get_primary_monitor (screen);
	return result;
}


static void
dock_class_init (DockClass * klass)
{
	dock_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DockPrivate));
	G_OBJECT_CLASS (klass)->finalize = dock_finalize;
}


static void
dock_instance_init (Dock * self)
{
	self->priv = DOCK_GET_PRIVATE (self);
}


static void
dock_finalize (GObject * obj)
{
	Dock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DOCK, Dock);
	_g_object_unref0 (self->priv->primary_monitor_label);
	_g_object_unref0 (self->priv->primary_monitor);
	_g_object_unref0 (self->priv->monitor_label);
	_g_object_unref0 (self->priv->monitor);
	_g_object_unref0 (self->priv->dock_preferences);
	G_OBJECT_CLASS (dock_parent_class)->finalize (obj);
}


GType
dock_get_type (void)
{
	static volatile gsize dock_type_id__volatile = 0;
	if (g_once_init_enter (&dock_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DockClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dock_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Dock), 0, (GInstanceInitFunc) dock_instance_init, NULL };
		GType dock_type_id;
		dock_type_id = g_type_register_static (gtk_grid_get_type (), "Dock", &g_define_type_info, 0);
		g_once_init_leave (&dock_type_id__volatile, dock_type_id);
	}
	return dock_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



